Public Class frmRubberRectangle

    Private _rubberRect As New RubberRectangle()

    Private _Selection As Rectangle = Rectangle.Empty

    Private Sub frmRubberRectangle_MouseDown(ByVal sender As Object, _
            ByVal e As MouseEventArgs) Handles MyBase.MouseDown

        _rubberRect.Start(sender, e)
    End Sub

    Private Sub frmRubberRectangle_MouseUp(ByVal sender As Object, _
            ByVal e As MouseEventArgs) Handles MyBase.MouseUp

        If e.Button <> MouseButtons.Left Then Return
        If Not _Selection.IsEmpty Then Invalidate(_Selection)
        _Selection = Me.RectangleToClient(_rubberRect.Rectangle)
        Invalidate(_Selection)
    End Sub

    ' Nur zur Anzeige des ausgewhlten Rechtecks.
    Protected Overloads Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        MyBase.OnPaint(e)

        ' Button.Enabled wird nicht in Form_MouseUp() gesetzt, weil das die 
        '  RubberRectangle-Zeichnung strt, falls letztere ber dem Button liegt
        btClearSelection.Enabled = Not _Selection.IsEmpty
        If _Selection.IsEmpty Then Return
        Dim rct As Rectangle = _Selection

        ' Bei Stiftbreite 1 muss das Rechteck 1 kleiner sein. Da die 
        '  Stiftposition beim Zeichnen aufgerundet wird lge sie ansonsten 
        '  auerhalb des Zeichenbereiches.
        rct.Size -= New Size(1, 1)
        e.Graphics.DrawRectangle(Pens.Red, rct)
    End Sub

    Private Sub btClearSelection_Click(ByVal sender As Object, _
            ByVal e As EventArgs) Handles btClearSelection.Click

        Me.Invalidate(_Selection)
        _Selection = Rectangle.Empty
    End Sub

End Class
